function draw(x,deltag,deltav,psi)  //x=(x,y,theta,deltav,deltag,v,w)
   theta=x(3);
   coque=[-1  5 7  7 5 -1 -1 -1; -2 -2 -1 1 2 2  -2 -2 ; ones(1:8)] ;
   voile=[-5*p6 0;0 0;1 1];
   gouvernail=[-1 1;0 0;1 1];
   [fv,fg]=forces(x,deltag,deltav,psi);
   Mfv=[-p6 -p6;0 -fv/1000;1 1];
   Mfg=[0 0;0 fg/100;1 1];
   R=[cos(theta),-sin(theta),x(1);sin(theta),cos(theta),x(2);0 0 1];
   coque=R*coque;
   Rdeltav=[cos(deltav),-sin(deltav),p8+p7;sin(deltav),cos(deltav),0;0 0 1];
   Rdeltag=[cos(deltag),-sin(deltag),-1;sin(deltag),cos(deltag),0;0 0 1];
   voile=R*Rdeltav*voile;
   Mfv=R*Rdeltav*Mfv;
   gouvernail=R*Rdeltag*gouvernail;
   Mfg=R*Rdeltag*Mfg;
   clf();
   xset('thickness',2);
   isoview(-1.5*ech,1.5*ech,-ech,ech)
   xset('color',color('magenta'));
   xset('color',color('black'));
   xstring(-ech+5,ech-5,["Wind = "+string(a)+"m/s"]) ;
   xstring(-ech+5,ech+5,["k = "+string(k)]) ;
   wind=[cos(psi) sin(psi);-sin(psi) cos(psi)]*[a;0];
   xarrows(-ech+[0,wind(1)],0.8*ech+[0,-wind(2)],2,color('green'));
   xpoly(coque(1,:),coque(2,:))
   if (cos(theta-psi)+cos(u(2))<0),
      xset('color',color('red'))
   else  
      xset('color',color('black'))
   end
   xpoly(voile(1,:),voile(2,:))
   xset('color',color('red'))
   xpoly(gouvernail(1,:),gouvernail(2,:))
   xset('color',color('green'))
   xset('thickness',1);
   xarrows(Mfv(1,:),Mfv(2,:),1,color('green'))
   xarrows(Mfg(1,:),Mfg(2,:),1,color('green'))
endfunction;
//---------------------------------------------
function [fv,fg]=forces(x,deltag,deltav,psi)  //x=(x,y,theta,v,w), 
     theta=x(3);v=x(4);
     fv=p4*a*sin(theta+deltav-psi); //-p4*v*sin(deltav)
     fg=p5*v*sin(deltag);
endfunction;
//---------------------------------------------
funcprot(0);
xset("pixmap", 1);
fdata=file('open','C:/jaulin/builder/getwind/data_testcase2.txt','unknown');
sortie=%F;
ech=2*60;
rand('normal');
psi=1;
p1=0.1; // drive du bateau
p2=100; // frottement de l'eau
p3=500; // frottement angulaire de l'eau
p4=500; // portance de la voile 1
p5=70;  // portance du gouvernail
p6=1.1; // distance mat-centre de pousse de la voile 1
p7=1.4; // distance de G au mat 1
p8=2;        // distance de G au gouvernail
p9=1/1000;   // masse du bateau en kg
p10=1/2000;  // moment d'inertie

//a=10;        // vent (m/sec)
x0=[0;0;2.7;2;0]; //x=(x,y,theta,v,w)
x=x0;
t=0;dt=0.05;



U1=[-0.2;%pi/5]*ones(1,100);
U2=[-0.5;%pi/6]*ones(1,100);
U3=[0.2;%pi/6]*ones(1,100);
U4=[-0.5;%pi/4]*ones(1,200);
U=[U1,U2,U3,U4];


kmax=size(U,2);
write(fdata,'% p1 p2 p3 p4 p5 p6 p7 p8 p9 p10');
write(fdata,p1);
write(fdata,p2);
write(fdata,p3);
write(fdata,p4);
write(fdata,p5);
write(fdata,p6);
write(fdata,p7);
write(fdata,p8);
write(fdata,p9);
write(fdata,p10);

write(fdata,'%--------------------------------------');

write(fdata,'% e_u e_xy e_theta e_dxy e_dtheta e_ddxy  e_ddtheta');
//e_u=0.002;e_xy=0.002; e_theta=0.002;e_dxy=0.002;e_dtheta=0.002;e_ddxy=0.002;e_ddtheta=0.002;
e_u=0.001;e_xy=0.001; e_theta=0.001;e_dxy=0.001;e_dtheta=0.001;e_ddxy=0.001;e_ddtheta=0.001;
write(fdata,e_u);
write(fdata,e_xy);
write(fdata,e_theta);
write(fdata,e_dxy);
write(fdata,e_dtheta);
write(fdata,e_ddxy);
write(fdata,e_ddtheta);
write(fdata,'% t u1 u2 cond deltav');
write(fdata,'% x y theta v'); 
write(fdata,'% w dx dy dtheta dv');
write(fdata,'%  dw ddx ddy');
write(fdata,'%  fg fv a psi');

for k=1:kmax,
     t=t+dt;
     u=U(:,k);
     a=10+2*sin(0.1*t);
     psi=1+cos(0.1*t);
     theta=x(3);v=x(4);w=x(5);
     cond=cos(theta-psi)+cos(u(2));
     if (cond<0),
        deltav=(%pi-theta+psi);     //pas tendu, dans le sens du vent
     else 
        deltav=sign(sin(theta-psi))*u(2);  // coute de voile tendue 
     end 
     [fv,fg]=forces(x,u(1),deltav,psi);
     dx=v*cos(theta)+p1*a*cos(psi);
     dy=v*sin(theta)+p1*a*sin(psi);
     dtheta=w;
     fdrag=-30*cos(theta+deltav-psi);  //noise
     dv=p9*(fv*sin(deltav)-fg*sin(u(1))-v*p2-fdrag*cos(deltav));
     houle=30*sin(theta)*cos(theta)*cos(0.1*t);
     dw=p10*((p6-p7*cos(deltav))*fv -p8*fg*cos(u(1))-p3*w+houle);
     ddx=dv*cos(theta)-v*w*sin(theta);
     ddy=dv*sin(theta)+v*w*cos(theta);
     Dx=[dx;dy;dtheta;dv;dw];
     //if (modulo(k,10)==0),
        write(fdata,'% ----');
        write(fdata,t);        write(fdata,u(1)); 
        write(fdata,u(2));     write(fdata,cond); 
        write(fdata,deltav);   write(fdata,x(1)); 
        write(fdata,x(2));     write(fdata,theta); 
        write(fdata,v);        write(fdata,dx); 
        write(fdata,dy);       write(fdata,dtheta); 
        write(fdata,dv);       write(fdata,ddx);
        write(fdata,ddy);      write(fdata,dw);
        write(fdata,fg);       write(fdata,fv);
        write(fdata,a);        write(fdata,psi);
     //end   
     x=x+Dx*dt; //Euler formula        
     draw(x,u(1),deltav,psi);
     xset("wshow");
end;
xdel();
file('close',fdata)


