//--------------------------------------------------------------------------
#include <vcl.h>
#include <list.h>
#pragma hdrstop

#include "main.h"
#include "Unit1.h"
#include "repere.h"
#include "box.h"
#include "interval.h"
#include <fstream>
int N_bissect=0;
interval Xk,Yk,Thetak,dXk,dYk,dThetak,ddXk,ddYk,ddThetak,U1k,U2k;

double eps=0.02;



//---------------------------------------------------------------------------
#pragma package(smart_init)
//----------------------------------------------------------------------


extern TForm1 *Form1;
fstream Fout;

void TForm1::Draw_wind(repere& R, double x,double y,double psi,double a, TColor col,int taille)
{   vector <double> windx;
    vector <double> windy;
    windx.clear(); windy.clear();
    windx.push_back(0); windy.push_back(0);
    windx.push_back(a); windy.push_back(0);
    windx.push_back(a-1.5); windy.push_back(0-1.5);
    windx.push_back(a); windy.push_back(0);
    windx.push_back(a-1.5); windy.push_back(0+1.5);
    for (int i=0;i<=windx.size()-1;i++)
    {
      double x1=cos(psi)*windx[i]-sin(psi)*windy[i]+x+5;
      double y1=sin(psi)*windx[i]+cos(psi)*windy[i]+y+5;
      windx[i]=x1;
      windy[i]=y1;
    }
    R.DrawPolygon(windx,windy,col,taille);
}




void TForm1::Draw_sailboat(repere& R, double x,double y,double theta,double deltag,
                           double deltav, double cond)
{   vector <double> coquex;
    vector <double> coquey;
    vector <double> voilex;
    vector <double> voiley;
    vector <double> gouvernailx;
    vector <double> gouvernaily;

    coquex.clear();   coquey.clear();
    coquex.push_back(-1); coquex.push_back(5);  coquex.push_back(7);  coquex.push_back(7);
    coquex.push_back(5);  coquex.push_back(-1); coquex.push_back(-1); coquex.push_back(-1);
    coquey.push_back(-2); coquey.push_back(-2); coquey.push_back(-1); coquey.push_back(1);
    coquey.push_back(2);  coquey.push_back(2);  coquey.push_back(-2); coquey.push_back(-2);

    for (int i=0;i<=coquex.size()-1;i++)
    {
      double x1=cos(theta)*coquex[i]-sin(theta)*coquey[i]+x;
      double y1=sin(theta)*coquex[i]+cos(theta)*coquey[i]+y;
      coquex[i]=x1;      coquey[i]=y1;
    }
    R.DrawPolygon(coquex,coquey,clBlue,1);
    voilex.clear();   voiley.clear();
    voilex.push_back(-5*p6);      voilex.push_back(0);
    voiley.push_back(0);          voiley.push_back(0);
    for (int i=0;i<=voilex.size()-1;i++)
    {
      double x1=cos(deltav)*voilex[i]-sin(deltav)*voiley[i]+p8+p7;
      double y1=sin(deltav)*voilex[i]+cos(deltav)*voiley[i];
      double x2=cos(theta)*x1-sin(theta)*y1+x;
      double y2=sin(theta)*x1+cos(theta)*y1+y;
      voilex[i]=x2;
      voiley[i]=y2;
    }
    if (cond<0)   {R.DrawPolygon(voilex,voiley,clRed,1);};
    if (cond>0)   {R.DrawPolygon(voilex,voiley,clGreen,1);};
    gouvernailx.clear(); gouvernaily.clear();
    gouvernailx.push_back(-1);      gouvernailx.push_back(1);
    gouvernaily.push_back(0);          gouvernaily.push_back(0);
    for (int i=0;i<=gouvernailx.size()-1;i++)
    { double x1=cos(deltag)*gouvernailx[i]-sin(deltag)*gouvernaily[i]-1;
      double y1=sin(deltag)*gouvernailx[i]+cos(deltag)*gouvernaily[i];
      double x2=cos(theta)*x1-sin(theta)*y1+x;
      double y2=sin(theta)*x1+cos(theta)*y1+y;
      gouvernailx[i]=x2;
      gouvernaily[i]=y2;
    }
    R.DrawPolygon(gouvernailx,gouvernaily,clRed,1);
}
//----------------------------------------------------------------------
void TForm1::Contract(box& Z, interval Xk,interval Yk,interval Thetak,
                           interval dXk,interval dYk,interval dThetak,
                           interval ddXk,interval ddYk,interval ddThetak,
                           interval U1k,interval U2k)
{   // W=(a,psi,v) // wind
    //v*cos(theta)+p1*a*cos(psi)=dx
    //v*sin(theta)+p1*a*sin(psi)=dy

    interval A=Z[1];
    interval Psi=Z[2];
    interval V=Z[3];
    interval cosTheta=Cos(Thetak);
    interval sinTheta=Sin(Thetak);
    interval dThetaSinTheta=dThetak*sinTheta;
    interval dThetaCosTheta=dThetak*cosTheta;
    interval cosPsi=Cos(Psi);
    interval sinPsi=Sin(Psi);
    interval VcosTheta=V*cosTheta;
    interval VsinTheta=V*sinTheta;
    interval p1A=p1*A;
    interval p1AcosPsi=p1A*cosPsi;
    interval p1AsinPsi=p1A*sinPsi;
    Cplus(dXk,VcosTheta,p1AcosPsi,1);
    Cplus(dYk,VsinTheta,p1AsinPsi,1);

    Cplus(dYk,VsinTheta,p1AsinPsi,-1);
    Cplus(dXk,VcosTheta,p1AcosPsi,-1);
    Cprod(p1AsinPsi,p1A,sinPsi,-1);
    Cprod(p1AcosPsi,p1A,cosPsi,-1);
    Cprod(p1A,p1,A,-1);
    Cprod(VsinTheta,V,sinTheta,-1);
    Cprod(VcosTheta,V,cosTheta,-1);
    Csin(sinPsi,Psi,-1);
    Ccos(cosPsi,Psi,-1);

//      dV=cosThetaddX+sinThetaddY
    interval dV=cosTheta*ddXk+sinTheta*ddYk;

//   V=(cosTheta*ddY-sinTheta*ddX)/dTheta
    V=Inter(V,(cosTheta*ddYk-sinTheta*ddXk)/dThetak);


//    ddX=dV*cosTheta-V*dThetaSinTheta
//    ddY=dV*sinTheta+V*dThetaCosTheta


    interval dVcosTheta=dV*cosTheta;
    interval dVsinTheta=dV*sinTheta;
    interval VdThetaSinTheta=V*dThetaSinTheta;
    interval VdThetaCosTheta=V*dThetaCosTheta;
    Cmoins(ddXk,dVcosTheta,VdThetaSinTheta,1);
    Cplus(ddYk,dVsinTheta,VdThetaCosTheta,1);
    Cplus(ddYk,dVsinTheta,VdThetaCosTheta,-1);
    Cmoins(ddXk,dVcosTheta,VdThetaSinTheta,-1);
    Cprod(VdThetaCosTheta,V,dThetaCosTheta,-1);
    Cprod(VdThetaSinTheta,V,dThetaSinTheta,-1);
    Cprod(dVsinTheta,dV,sinTheta,-1);
    Cprod(dVcosTheta,dV,cosTheta,-1);


                     /*interval Thetak_Psi=Thetak-Psi;           //pour contraindre la voile  ne pas depasser
                     interval CosThetak_Psi=Cos(Thetak_Psi);     // la longueur de corde.
                     interval Cos_U2k=Cos(U2k);
                     interval Cond=CosThetak_Psi+Cos_U2k;
                     interval Ds1=M_PI+Psi-Thetak;
                     interval SinThetak_Psi=Sin(Thetak_Psi);
                     interval Sign_SinThetak_Psi=Sign(SinThetak_Psi);
                     interval Ds2=Sign_SinThetak_Psi*U2k;
                     interval Deltas= Chi(Cond, Ds1,Ds2);

                     Deltas=Inter(Deltas,interval(-U2k.sup,U2k.sup));

                     Cchi(Deltas,Cond, Ds1,Ds2);
                     Cprod(Ds2,Sign_SinThetak_Psi,U2k,-1);
                     Csign(Sign_SinThetak_Psi,SinThetak_Psi,-1);
                     Csin(SinThetak_Psi,Thetak_Psi,-1);
                     Psi=Inter(Psi,Ds1-M_PI+Thetak);
                     Cplus(Cond,CosThetak_Psi,Cos_U2k,-1);
                     Ccos(CosThetak_Psi,Thetak_Psi,-1);
                     Cmoins(Thetak_Psi,Thetak,Psi,-1);    */


    Z[1]=A;
    Z[2]=Psi;
    Z[3]=V;
}

void TForm1::SIVIA(box& Z0)

{   box Z;
    list<box> L;
    L.push_back(Z0);
    while (!L.empty())
    { Z=L.front();

      //Form1->R1.DrawCadre(Z,clBlue,psSolid,1,2,1);
      L.pop_front();
      bool sortie=false;
      while (!sortie)
       {  box Zold(Z);
          Contract(Z,Xk,Yk,Thetak,dXk,dYk,dThetak,ddXk,ddYk,ddThetak,U1k,U2k);
          if (Z.IsEmpty())          sortie=true;
          if (decrease(Zold,Z)<0.1) sortie=true;
       }
      if (!Z.IsEmpty())
      {  if (N_bissect>300) /*(Z.Width()<eps)*/
            {     box Wpol(2);
                  interval A=Z[1];
                  interval Psi=Z[2];
                  interval V=Z[3];
                  Wpol[1]=A*Cos(Psi);
                  Wpol[2]=A*Sin(Psi);
                  Form1->R1.DrawBox(Wpol,clBlack,clBlack,bsSolid,1,2);
                  double ak=Form1->a[k];
                  double psik=Form1->psi[k];
                  Form1->R1.DrawPoint(ak*cos(psik),ak*sin(psik),clRed,2);

                  interval Cond=Cos(Thetak-Psi)+Cos(U2k);
                  interval Ds1=M_PI+Psi-Thetak;
                  interval Ds2=Sign(Sin(Thetak-Psi))*U2k;
                  interval Deltas= Chi(Cond, Ds1,Ds2);


                  box Force(2);
                  Force[1]=p5*V*Sin(U1k);
                  Force[2]=p4*A*Sin(Thetak+Deltas-Psi);
                  int epais=2;
                  R_fr.DrawLine(t[k],Force[1].inf-20,t[k],Force[1].sup+20,clBlack,psSolid,epais);
                      R_fr.DrawPoint(t[k],fr[k],clGray,1);
                  R_fs.DrawLine(t[k],Force[2].inf-50,t[k],Force[2].sup+50,clBlack,psSolid,epais);
                      R_fs.DrawPoint(t[k],fs[k],clGray,1);
                  R_cond.DrawLine(t[k],Cond.inf-0.03,t[k],Cond.sup+0.03,clBlack,psSolid,epais);
                      R_cond.DrawPoint(t[k],cond[k],clGray,1);
                  R_a.DrawLine(t[k],A.inf-0.1,t[k],A.sup+0.1,clBlack,psSolid,epais);
                      R_a.DrawPoint(t[k],a[k],clGray,1);
                  R_psi.DrawLine(t[k],Psi.inf-0.02,t[k],Psi.sup+0.02,clBlack,psSolid,epais);
                      R_psi.DrawPoint(t[k],psi[k],clGray,1);
                  R_deltas.DrawLine(t[k],Deltas.inf-0.02,t[k],Deltas.sup+0.02,clBlack,psSolid,epais);
                      R_deltas.DrawPoint(t[k],deltas[k],clGray,1);
                  R2.DrawBox(Force,clBlack,clBlack,bsSolid,1,2);
                  R2.DrawPoint(fr[k],fs[k],clRed,2);
                  Draw_wind(R_wordhat,Center(Xk),Center(Yk),Center(Psi),Center(A), clBlack,1);
                  Draw_wind(R_trueword,x[k],y[k],psi[k],a[k],clBlack,1);
                  Draw_sailboat(R_trueword,x[k],y[k],theta[k],u1[k],deltas[k],cond[k]);
                  Draw_sailboat(R_wordhat,Center(Xk),Center(Yk),Center(Thetak),Center(U1k),Center(Deltas),Center(Cond));
            }
         else  {   box Z1,Z2;
                   Bisect(Z,Z1,Z2);
                   N_bissect++;
                   L.push_back(Z1);
                   L.push_back(Z2);
               }
      }
    }
    L.clear();
} ;




//----------------------------------------------------------------------
void TForm1::GO(double amin,double amax,double phimin,double phimax)
{ Fout.open("info.txt",fstream::out);
  N_bissect=0; 

    Xk=X[k];          Yk=Y[k];        Thetak=Theta[k];
    dXk=dX[k];        dYk=dY[k];      dThetak=dTheta[k];
    ddXk=ddX[k];      ddYk=ddY[k];    ddThetak=ddTheta[k];
    U1k=U1[k];        U2k=U2[k];



  Fout <<"Dbut\n"<<"\n";

                  double ak=Form1->a[Form1->k];
                  double psik=Form1->psi[Form1->k];
                  double vk=Form1->v[Form1->k];


  box Z(3);
  Z[1]=interval(amin,amax);
  Z[2]=interval(phimin,phimax);
  Z[3]=interval(0,40);  // c'est v
  SIVIA(Z);

  Fout << "N_bissect = " <<N_bissect<<"\n";

  Fout.close();
} ;

//----------------------------------------------------------------------


